/*  ocrad - Optical Character Recognition program
    Copyright (C) 2003 Antonio Diaz Diaz.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <cstdio>
#include <cstdlib>
#include "common.h"


void internal_error( const char * s ) throw()
  {
  fprintf( stderr, "%s internal error: %s.\n", PROGRAM_NAME, s );
  exit( 3 );
  }


bool similar( int a, int b, int percent_dif ) throw()
  {
  int difference = abs( a - b );
  if( percent_dif > 0 && difference <= 1 ) return true;
  int max_abs = ( abs(a) >= abs(b) ? abs(a) : abs(b) );
  return ( difference * 100 <= max_abs * percent_dif );
  }
